// C Header File
// Created 11/9/2002; 8:23:26 PM

const char *const title_version_string = "SkyRacer v0.55b";
const char *const author_string = "By Malcolm Smith";

// The appearance and behavior of the game can be adjusted through these variables
#if defined(USE_TI89)
#define SCREEN_WIDTH				160		// in pixels
#define SCREEN_HEIGHT				100		// in pixels
#define NUM_TILES_HIGH				4		// this many tiles are visible on the screen at once
											//   changing this value may require some slight code adjustment
#define PLANE_WIDTH					160		// needs to be a multiple of 32, otherwise there will be
											//   a gap in the middle due to truncation in buildcoordtable()
#elif defined(USE_TI92PLUS)
#define SCREEN_WIDTH				240		// in pixels
#define SCREEN_HEIGHT				100		// in pixels
#define SCREEN_Y_DELTA			 28   // in pixels, difference between real screen height
											//   and the SCREEN_HEIGHT specified
#define NUM_TILES_HIGH				4		// this many tiles are visible on the screen at once
											//   changing this value may require some slight code adjustment
#define PLANE_WIDTH					240		// needs to be a multiple of 32, otherwise there will be
											//   a gap in the middle due to truncation in buildcoordtable()
#elif defined(USE_V200)
#define SCREEN_WIDTH				240		// in pixels
#define SCREEN_HEIGHT				100		// in pixels
#define SCREEN_Y_DELTA			 28   // in pixels, difference between real screen height
											//   and the SCREEN_HEIGHT specified
#define NUM_TILES_HIGH				4		// this many tiles are visible on the screen at once
											//   changing this value may require some slight code adjustment
#define PLANE_WIDTH					240		// needs to be a multiple of 32, otherwise there will be
											//   a gap in the middle due to truncation in buildcoordtable()											
#endif
											
#define SHIP_X 16
#define SHIP_Y 16

#define LIVES 4

#define XPOS (PLANE_WIDTH/2-(SHIP_X/2)-1)
#define YPOS (PLANE_HEIGHT-SHIP_Y-5)

				// = number of pixels forward for each one left/right
#define MAX_SCROLL_SPEED	\
		(NUM_TILES_HIGH*TOP_TILE_HEIGHT)/(SCREEN_WIDTH/8)	// max speed: at least one tile left/right for each one up
#define TOP_TILE_HEIGHT		\
		(SCREEN_HEIGHT/(NUM_TILES_HIGH*(NUM_TILES_HIGH+1)/2))
				// ugly calculation; must be <= SCREEN_HEIGHT
#define PLANE_HEIGHT		\
		(TOP_TILE_HEIGHT*NUM_TILES_HIGH*(NUM_TILES_HIGH+1)/2)
//#if (PLANE_HEIGHT > SCREEN_HEIGHT)
//	#error PLANE_HEIGHT must be less than SCREEN_HEIGHT
//#endif

#define LEVELSIZE	(levelsizes[level])

#define BALLSPRITEWAIT 10

#define ACCELERATION_TIME 40
#define JUMP_WAIT 6


#define JUMPSTEPS (14*JUMP_WAIT)
const char jump_arc[JUMPSTEPS]=
{
2,2,2,2,2,2,
2,2,1,2,2,2,
2,2,1,1,2,2,
2,1,1,1,2,2,
2,1,1,1,1,2,
1,1,1,1,1,2,
1,1,1,1,1,1,
1,1,1,0,1,1,
1,1,0,0,1,1,
1,0,0,0,1,1,
1,0,0,0,0,1,
1,0,0,0,0,1,
0,0,0,0,0,0,
0,0,0,0,0,0
};

typedef struct
{
	short row;
	short col;
} RowCol;


char HW2;

unsigned short zspeed;
short jumpplace;
short jumpdir;
short level;
short lives;
char ballspritecycle;
short ballspritewait;
char duringintro = 1;
char endlev_quit;
char death_quit;
RowCol jump;

short xpos;
unsigned short spawnx;
short ypos;
unsigned short wait;
short mainIsJumping;
short mainIsDescending;
short hangtime;
short jumptype;

BYTE* coordtable = NULL;
//BYTE* planebuffer = NULL;
BYTE *external_level;
	
char contrastcur;	
	
short tileoffsets[NUM_TILES_HIGH];
short scrollcycle = 0, tilecycle = 0;
short toptileindex = 0;

char *track_light,*track_dark;
char *light,*dark;

enum IntroTags
{
	AT_BEGINNING,AT_END
};


//Prototypes
static inline void buildcoordtable(void);
static inline void newtile(void);
static inline void drawinitialplane(void);
static inline void drawplaneline(BYTE data, short line);
static inline short ScrollPlane(void);
static inline void ModifiedFastDrawHLine(unsigned char* plane,short x1,short x2,short y);
short MainReset(void);
